/* Generated by powerful Codeforces Tool
 * Author: $%U%$
 * Time: $%Y%$-$%M%$-$%D%$ $%h%$:$%m%$
 **/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<ll, ll> pii;


template<class T> bool ckmin(T& a, const T& b){ return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b){ return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MOD = 998'244'353;

const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

ll N, M;

void solve(){
    // Code goes here ...
    cin >> N >> M;
    vector<ll> a(N), b(M);
    R(i, N) cin >> a[i];
    R(i, M) cin >> b[i];

    set<ll> as(begin(a), end(a)), bs(begin(b), end(b));

    vector<ll> apairs, bpairs;
    while(ssize(as) >= 2){
        ll l = *begin(as), h = *rbegin(as);
        apairs.push_back(h - l);
        as.erase(l);
        as.erase(h);
    }
    while(ssize(bs) >= 2){
        ll l = *begin(bs), h = *rbegin(bs);
        bpairs.push_back(h - l);
        bs.erase(l);
        bs.erase(h);
    }

    vector<ll> res = {0};
    int aptr = 0, bptr = 0;
    for(int k = 0;;k++){
        // ll ares, bres;
        // ares = bres = res[k - 1];
        ll again = -INF, bgain = -INF;

        // take from apairs
        if(aptr * 2 + bptr + 2 <= N and aptr + bptr * 2 + 1 <= M){
            again = apairs[aptr];
        }
        else if(aptr * 2 + bptr + 3 <= N and bptr > 0){
            again = apairs[aptr] + apairs[aptr + 1] - bpairs[bptr - 1];
        }

        // take from bpairs
        if(aptr * 2 + bptr + 1 <= N and aptr + bptr * 2 + 2 <= M){
            bgain = bpairs[bptr];
        }
        else if(aptr + bptr * 2 + 3 <= M and aptr > 0){
            bgain = bpairs[bptr] + bpairs[bptr + 1] - apairs[aptr - 1];
        }

        // no more option possible
        if(again == -INF and bgain == -INF){
            cout << k << endl;
            R(i, k) cout << res[i + 1] << " ";
            cout << endl;
            break;
        }
        // merge results
        else{
            if(again >= bgain){
                if(aptr + bptr * 2 + 1 <= M){
                    // cerr << "take a" << endl;
                    aptr++;
                }
                else{
                    // cerr << "take 2a minus 1b" << endl;
                    aptr++;
                    aptr++;
                    bptr--;
                }
                res.push_back(res[k] + again);
            }
            else{
                if(aptr * 2 + bptr + 1 <= N){
                    // cerr << "take b" << endl;
                    bptr++;
                }
                else{
                    // cerr << "take 2b minus 1a" << endl;
                    bptr++;
                    bptr++;
                    aptr--;
                }
                res.push_back(res[k] + bgain);
            }
        }

    }
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    cin >> T;
    while(T--)
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
